<script setup lang="ts">
import { ref } from "vue";
import { useUserStore } from "@/stores/user";
const userStore = useUserStore();
const form = ref<vForm | null>(null);
const save = async () => {
  const { valid } = await form.value!.validate();
  if (valid) {
    userStore.saveUser();
  }
};
const clear = () => {
  userStore.dialog = false;
  userStore.clear;
};
</script>
<template>
  <v-row justify="center">
    <v-dialog v-model="userStore.dialog" persistent>
      <v-card>
        <v-card-title>
          <span class="text-h5">User Profile</span>
        </v-card-title>
        <v-card-text>
          <v-form ref="form">
            <v-container>
              <v-row>
                <v-col cols="12">
                  <v-text-field
                    label="Login*"
                    v-model="userStore.editedUser.login"
                    :rules="[
                      (v) => !!v || 'Login required',
                      (v) =>
                        v.length >= 5 || 'Login must be more than 5 characters',
                    ]"
                    required
                  ></v-text-field>
                </v-col>
                <v-col cols="12">
                  <v-text-field
                    label="Name"
                    v-model="userStore.editedUser.name"
                    :rules="[
                      (v) => !!v || 'Login required',
                      (v) =>
                        v.length >= 5 || 'Login must be more than 5 characters',
                    ]"
                  ></v-text-field>
                </v-col>
                <v-col cols="12">
                  <v-text-field
                    label="Password*"
                    type="password"
                    v-model="userStore.editedUser.password"
                    :rules="[
                      (v) => !!v || 'Password required',
                      (v) =>
                        v.length >= 8 ||
                        'Password must be more than 8 characters',
                      (v) =>
                        /^(?=.*\d)(?=.*[!@#$%^&*])(?=.*[a-z])(?=.*[A-Z]).{8,}$/.test(
                          v
                        ) ||
                        'Password must contain at least one uppercase letter, one lowercase letter, one number and one special character',
                    ]"
                    required
                  ></v-text-field>
                </v-col>
              </v-row>
            </v-container>
          </v-form>
          <small>*indicates required field</small>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue darken-1" text @click="clear"> Close </v-btn>
          <v-btn color="blue darken-1" text @click="save"> Save </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
</template>
<style scoped></style>
